:- dynamic(angle/1).
:- consult('plnxt.pl').

start :- 
nxt_open,
A is 0,
trigger_create(_,check_distance,remember(A)),
nxt_rotate(200,30),
trigger_create(_,nxt_is_stopped,go_on(A)).
check_distance :-
nxt_ultrasonic(Value, force),
Value < 40.

remember(A) :-
assert(angle(A)).

go_on(A) :- 
A is A + 30,
A =< 360,
trigger_create(_,check_noise(A),start2),
trigger_create(_,check_distance,remember(A)),
nxt_rotate(200,30),
trigger_create(_,nxt_is_stopped,go_on(A)).

check_noise(A) :-
nxt_sound(Value,force),
Value > 30,
A > 360.

start2 :-
B is 0,
trigger_create(_,[check_distance,not(angle(B)],come_closer),
nxt_rotate(200,30),
trigger_create(_,nxt_is_stopped,go_on2(B)).

go_on2(B) :-
B is B + 30,
B =< 360,
trigger_create(_,[check_distance,not(angle(B)],come_closer),
nxt_rotate(200,30),
trigger_create(_,nxt_is_stopped,go_on2(B)).
